//CellNX̐錾
class Cell{

public:
	float latitude;				// ܓx [b] latitude [second]
	float longitude;				// ox [b] longitude [second]

	float topoScale;				// ԕ\bPʂŗ^ spatial resolution given as second unit

	int down;					/* (NN1,NE2,EE3,SE4,SS5,SW6,WW7,NW8,͌0,En9,lȂ10,C-1) */
	int basin;					/* Wʐ */

	int numberOfUpStreamGrid;	/* 㗬Obh̐ */
	int riverNumber;			/* ͌ꂼԍŁÃObhǂ̉͌ɂȂĂ邩 */

	float longitudinalLength;	/* ox̂PObh̒[m] */
	float med;					/* Ԓl[m] */

	class ROF* ROFCell;			/* ̃Obh܂܂~ʃZ */
	class Cell* downStreamGrid;	/* Obh */
	class Cell* upStreamGrid[7];/* 㗬Obh */

	bool isThisGridEnd;			/* [ObhA܂͊CObh */

	float*** mQn_memory;		/* ЂƌmQnLz */


//member and member function for kinematic wave method

	// p^
	double mK;		// R = mK * pow(A, mZ) (mn)
	double mZ;		// R = mK * pow(A, mZ) (mn)
	double mMan;	// }jȎexW (m-s)
	double mL;		// ͓ (m)
	double mB;      // ͓ (m)
	double mG;		// ͓z (tangent ̒l)
	int mDiv;		// ԕ (-)
	double mDx;		// ԍԊu (m)
	int mDt;		// ԍԊu (sec)
	double mTheta;	// d݌W (-)

 	double mAlpha;  // kinematic 萔 
					 // mAlpha = 1 / mMan * pow(mK, 2/3) * sqrt(mG)

 	double mM;		// kinematic 萔
					// mM = 1 + 2/3*mZ

	// ԗ
	double* mQc;	// current_time ł̗ (m3/s)
	double* mQn;	// current_time+time_step ł̗ (m3/s)
	double mQlc;	// current_time ł̑ (m2/s)
	double mQln;	// current_time+time_step ł̑ (m2/s)


	void setElevation(int rowStep, int colStep, int row, int col, float SWlat, float SWlon, float elevation, float topoScale);
	void setNULL();
	void setDownStreamGrid(int row, int col, class Cell** cell2);	
	void setUpStreamGrid();
	void countNumberOfUpStreamGrid();
	void setROFCell(ROF** fROF, int row_ROF, int col_ROF, int*& rofRC);
	void PutROFCell(ROF** fROF, int ix, int iy);

	void initialize(double ini_lateral);
	void Set_parameter(double mMan_slope, double mMan_channel, int thre_basin, 
		int x_Div, int t_Div, double theta, int t_step_num, int Ndays);

	void getLateralRunoff(int n_day, int n_hour);

	void Calculate(int day, int hour, int nt);

	void writeQ(int year, int month, int day_num, int t_step_num, FILE *fout);
    void writeQBi(int year, int month, int day_num, int t_step_num, FILE *fout);
	float GetHourlyFlow(int day, int hour, int t_step_num);
	float GetDailyFlow(int day, int t_step_num);
	float GetHourlyFlowMax(int day, int t_step_num);
	void deleteQandA(int Ndays);
};

